// sweep(twist) generator for wired demo

#include <stdio.h>
#include <math.h>

#define SWEEP_VARIATION	10.0
#define SWEEP_RADIUS	32.0
#define XCENTER	64
#define ZCENTER	128.0
#define MASK	0x40

#define PI 3.141592653

int main(int argc,char *argv[])
{

FILE *file;
float zbuf[128];
int col[128];
unsigned char data[16*16*16];

int i,ang,line,x,bpl;
float rad,z;
double angle;

int	ofs;

	for(line=0;line<128;line++) {

		for(i=0;i<128;i++)		//clear span zbuffer+vbuffer
			col[i]=zbuf[i]=0;
		for(ang=0; ang<512; ang++) {
			angle=(double)ang*2*PI/512.0;
			rad=SWEEP_RADIUS+SWEEP_VARIATION*cos((double)((line*2.0*PI/128.0)+angle));
			x = XCENTER+(int)(rad*cos(angle));
			z = ZCENTER+rad*sin(angle);

//			printf("[%d] %f %d %f\n",line,rad,x,z);

			if (x<0 || x>127) {
				printf("alert line=%d ang=%d angle=%f rad=%f x=%d z=%f\n",line, ang,angle,rad,x,z);
				exit(1);
			}


			if ((line*2+ang*2)&MASK) {
				if (zbuf[x]==0 || z<zbuf[x]) {
					zbuf[x]=z;
					col[x]=0x0100;	//black
				} else {
					if ((col[x]&0x0100)==0)	//white is near
						col[x]=0x0101;		//make it gray
				}
			} else {
				if (zbuf[x]==0 || z<zbuf[x]) {
					zbuf[x]=z;
					if ((col[x]&0x0100)==0)
						col[x]=0x0001;	//white
					else col[x]=0x0101;	//gray
				}
			}

//			printf("[%d] %d %f\n",line,x,zbuf[x]);

		}

		ofs=(((line>>3) & 0x0f)<<8) + ((line&0x07)<<1);
//		printf("offset %d\n",ofs);

		for (i=0; i<128; i+=8) {
			bpl=(col[i+0]<<7)+(col[i+1]<<6)+(col[i+2]<<5)+(col[i+3]<<4) + \
				(col[i+4]<<3)+(col[i+5]<<2)+(col[i+6]<<1)+col[i+7];
			data[ofs+0]= bpl    &0xff;
			data[ofs+1]=(bpl>>8)&0xff;
			ofs+=16;
		}

	}

	file=fopen("sweep.bin","wb");
	fwrite(&data,sizeof(char),4096,file);
	fclose(file);

	return 0;
}