;This is the source of R-Lab' contribution to GBDev'2000 - "Wired" intro
;This code released for educational purposes only.
;We hope it helps someone to increase his/her coding skills.
;If you want to use 3D code in your commercial production,
;get in touch with R-Lab.
;If you have tech questions about the source, mail it to [vvid@mail.ru]
;
;R-Lab'2000 (http://r-lab.nm.ru) (mailto:r-lab@mail.ru)


	INCLUDE "hardware.inc"

;player located at $7700
;music  located at $5e00
;player vars at $cf00 [256]

init_mus	equ	$7700
play_mus	equ	$7703

vbl_hook	equ	$fff0
lcd_hook	equ	$fff3
timer		equ	$fff6
rambank		equ	$fff8

;- macros -----------------------------------------------------

LCD_WAIT: 	MACRO
		ldh     a,[rSTAT]
		and     STATF_BUSY
		jr      nz,@-4
		ENDM

;- general vars -----------------------------------------------
		rsset	$ff90
exec_ptr	rw	1
sp_		rw	1
tmp0		rb	1
tmp1		rb	1

;- sweep vars -------------------------------------------------

vpage		rb	1
sweep_ytop	rb	1
sweep_ybot	rb	1
sweep_rot	rb	1

sweep_zbuf	equ	$c000

color_sweep_bg0	equ	%0001111111111111

LY_HIGH		equ	90
LY_LOW		equ	0

;- 3d vars -----------------------------------------------------

line_vpage	rb	1
hbb_adr		rb	1
flip_req	rb	1

m0		rb	1
m1		rb	1
m2		rb	1
m3		rb	1
m4		rb	1
m5		rb	1
m6		rb	1
m7		rb	1
m8		rb	1
xn		rb	1
yn		rb	1
rt1		rb	1;\
rt2		rb	1;/
cpnt		rb	1
vcnt		rb	1
acx		rb	1
asx		rb	1
acy		rb	1
asy		rb	1
acz		rb	1
asz		rb	1
opx		rb	1
opy		rb	1
opz		rb	1
rZOOM		rb	1

LINE_VMASK	equ	$20
LINE_DMASK	equ	$10
line_vbuffer	equ	$d000	;[4096]
tbpnt		equ	$c000	;[256]
objdata		equ	$c100	;[256] mem for object data
skew_tb		equ	$c200	;[256] x skew for rotated points (signed bytes)
tmpbuf		equ	$c300	;[256]

oh1		equ	objdata
oh2		equ	objdata+8
oh3		equ	objdata+16
oh4		equ	objdata+24

;- intro vars --------------------------------------------------

tmp_rgb		equ	tmpbuf

;- timing ------------------------------------------------------

time_pat	equ	192	;pattern (64*3)
;time_intro_1	equ	64	;show r-lab presents
time_start	equ	1*time_pat
time_show_title	equ	3*time_pat+time_start
time_continue	equ	1*time_pat+time_show_title
time_fx1	equ	3*time_pat+time_continue
time_fx2	equ	3*time_pat+time_fx1
time_fx3	equ	2*time_pat+time_fx2

	SECTION "note0",HOME[$0000]
	db	">>(c)R-Lab'Y2K<<"
	db	"    contact :   "
	db	"  r-lab@mail.ru "
	SECTION "vbl",HOME[$40]
	jp	vbl_hook
	SECTION "lcd",HOME[$48]
	jp	lcd_hook
        SECTION "main",HOME[$100]
        nop
        jp      Start

        NINTENDO_LOGO

	db "WIRED BY R-LAB",0	; Cart name 15 bytes
	db $80
	db 0,0,0		; Not used
	db $00			; Cart type rom
	db 0			; ROM Size    32k
	db 0			; RAM Size
	db 1,1			; Maker ID
	db 0			; Version     =0
	db 0			; Complement
	dw 0			; Checksum

Start	ld	sp,$fff0

	call	setup0

	call	init_part_intro

;initial palette= all black

	xor	a
	ld	[rSTAT],a
	ld	a,$81
	ld	[rLCDC],a

	ld	a,IEF_VBLANK
	ld	[rIE],a
	halt

	call	part_intro
	call	move_logo2
	call	part_cube
	call	show_title
	call	part_demo
	call	part_sweep

	jr	@

init_part_intro

	call	make_scr2012

	ld	a,1
	ld	[rVBK],a

	ld	hl,$9800+3*32
	ld	b,32*12/4
	push	hl
	xor	a
	call	memset
	ld	[rVBK],a
	pop	hl
	ld	b,32*12/4
	ld	a,$03
	call	memset

	xor	a
	ld	[rVBK],a

	ld	hl,logo1_tiles
	ld	de,$8800
	ld	b,56
	call	load_tiles_lcd

	ld	hl,logo1_map0
	ld	de,$9800+32*6+2
	ld	b,16
	ld	c,6
	call	load_vmap_lcd
	ret

part_intro		;time = 1 pattern

	ld	bc,$0000
	ld	e,$20

.fx1	halt
	ld	hl,intro_rgb0
	xor	a
	call	set_whole_pal
	push	bc
	push	de
	call	demostuff
	pop	de
	pop	bc
	ld	a,c
	add	a,8
	ld	c,a
	dec	e
	jr	nz,.fx1

	ld	bc,$3fff
	ld	e,$20
.fx2	halt
	ld	hl,intro_rgb1	;bg color
	xor	a
	call	set_whole_pal
	push	bc
	push	de
	call	demostuff
	pop	de
	pop	bc
	ld	a,c
	sub	4
	ld	c,a
	dec	b
	dec	b
	dec	e
	jr	nz,.fx2

	halt
	call	demostuff

	ld	hl,vbl_hook
	ld	a,$c3
	ld	[hl+],a
	ld	de,null_vbl
	ld	[hl],e
	inc	l
	ld	[hl],d

	ld	b,$c0-$41
haltb	halt
	dec	b
	jr	nz,haltb
	ret

;a-pal/color c-scale b-bias
set_whole_pal
	push	bc
	srl	b
	push	af
	call	set_scaled_bgcolor
	pop	af
	add	a,2
	push	af
	call	set_scaled_bgcolor
	pop	af
	add	a,2
	push	af
	call	set_scaled_bgcolor
	pop	af
	add	a,2
	call	set_scaled_bgcolor
	pop	bc
	ret

move_logo2

	ld	a,40
	ld	[rSCX],a

	ld	hl,null_pal
	xor	a
	ld	b,2*4
	call	load_bpal

	call	make_scr2012
	call	cls

	ld	hl,logo2_tiles
	ld	de,$9000+$40*16
	ld	b,60
	call	load_tiles_lcd

	halt

	ld	hl,part_3d_pal
	xor	a
	ld	b,2*4
	call	load_bpal

	ld	a,40
.mv	halt
	dec	a
	ld	[rSCX],a
	jr	nz,.mv

	ret

part_cube
	xor	a
	ldh	[line_vpage],a
	ld	[flip_req],a
	dec	a
	ld	[rZOOM],a

	ld	hl,vbl_hook
	ld	a,$c3
	ld	[hl+],a
	ld	de,wires_vbl
	ld	[hl],e
	inc	l
	ld	[hl],d

	ld	hl,exec_ptr
	ld	[hl],exec_data&$ff
	inc	hl
	ld	[hl],exec_data>>8

	ld	a,$89		;screen #2 visible!
	ldh	[rLCDC],a
	xor	a
	ld	[rVBK],a	;write to 9c00 9800 visible

	ld	hl,cube_hd
	ld	de,oh1
	call	load_obj
	ld	a,[line_vpage]
	xor	$80
	call	fast_cls
	ld	a,$ff
	ld	[rZOOM],a

.fx1	ld	a,[line_vpage]
	call	fast_cls
	ld	hl,oh1
	call	render_obj
	ld	hl,oh1
	dec	[hl]
	inc	l
	inc	[hl]
	inc	[hl]
	inc	l
	inc	[hl]
	inc	l
	inc	l
	inc	l
	ld	a,[rZOOM]
	ld	[hl],a
	call	flip_vb

	ld	de,time_show_title-1
	call	cmp_time
	jr	nc,.fx1

	halt
	halt	;let finish blit

	ret

part_demo

	xor	a
	ldh	[line_vpage],a
	ld	[flip_req],a

	ld	a,$89		;screen #2 visible!
	ldh	[rLCDC],a
	xor	a
	ld	[rVBK],a	;write to 9c00 9800 visible

	ld	hl,black_pal
	xor	a
	ld	b,8*4
	call	load_bpal

	call	cls
	call	make_scr2012

	ld	hl,logo2_tiles
	ld	de,$9000+$40*16
	ld	b,60
	call	load_tiles_lcd

	halt

	ld	hl,part_3d_pal
	xor	a
	ld	b,2*4
	call	load_bpal

	ld	hl,cube_hd
	ld	de,oh1
	call	load_obj
	ld	hl,cube1_hd
	ld	de,oh2
	call	load_obj
	ld	hl,cube2_hd
	ld	de,oh3
	call	load_obj

	ld	a,[line_vpage]
	xor	$80
	call	fast_cls
	ld	a,$58
	ld	[rZOOM],a

.fx1	ld	a,[line_vpage]
	call	fast_cls

	ld	hl,oh1
	call	render_obj
	ld	hl,oh1
	dec	[hl]
	inc	l
	inc	[hl]
	inc	l
	inc	[hl]
	inc	l
	inc	l
	inc	l
	ld	a,[rZOOM]
	ld	[hl],a

	ld	hl,oh2
	call	render_obj
	ld	hl,oh2
	dec	[hl]
	dec	[hl]
	inc	l
	inc	[hl]
	inc	[hl]
	inc	l
	inc	[hl]
	inc	[hl]
	inc	l
	inc	l
	inc	l
	ld	a,[rZOOM]
	ld	[hl],a

	ld	hl,oh3
	call	render_obj
	ld	hl,oh3
	inc	[hl]
	inc	l
	inc	[hl]
	dec	[hl]
	inc	l
	dec	[hl]
	inc	l
	inc	l
	inc	l
	ld	a,[rZOOM]
	ld	[hl],a

	call	flip_vb

	ld	de,time_fx1-2
	call	cmp_time
	jr	nc,.fx1

	ld	hl,chain_hd
	ld	de,oh1
	call	load_obj

	ld	a,$60
	ld	[rZOOM],a

.fx2	ld	a,[line_vpage]
	call	fast_cls
	ld	hl,oh1
	call	render_obj
	ld	hl,oh1
	dec	[hl]
	inc	l
	inc	[hl]
	inc	l
	dec	[hl]
	inc	l
	inc	l
	inc	l
	ld	a,[rZOOM]
	ld	[hl],a
	call	flip_vb

	ld	de,time_fx2-2
	call	cmp_time
	jr	nc,.fx2

	ld	hl,tball_hd
	ld	de,oh1
	call	load_obj

	ld	a,$70
	ld	[rZOOM],a

.fx3	ld	a,[line_vpage]
	call	fast_cls
	ld	hl,oh1
	call	render_obj
	ld	hl,oh1
	dec	[hl]
	dec	[hl]
	inc	l
	inc	[hl]
	inc	[hl]
	inc	l
	dec	[hl]
	inc	l
	inc	l
	inc	l
	ld	a,[rZOOM]
	ld	[hl],a
	call	flip_vb

	ld	de,time_fx3-2
	call	cmp_time
	jr	nc,.fx3


	halt
	halt	;let finish blit
	ret

;hl= object desc = rx,ry,rz,px,py,pz,objdata

render_obj
	push	hl
	call	rsetup
	call	rotate_obj
	pop	hl
	ld	a,l
	add	a,6
	ld	l,a
	ld	a,[hl+]
	ld	h,[hl]
	ld	l,a		;obj data
	ld	a,[hl+]
	ld	h,[hl]
	ld	l,a		;edge data
.rend	ld	a,[hl+]
	cp	$ff
	ret	z
	add	a,a
	ld	e,a
	ld	d,tbpnt>>8
	ld	a,[de]
	ld	c,a	;x1
	inc	e
	ld	a,[de]
	ld	b,a	;y1
	ld	a,[hl+]
	add	a,a
	push	hl
	ld	h,d
	ld	l,a
	ld	a,[hl+]
	ld	h,[hl]	;y2
	ld	l,a	;x2
	call	draw_line
	pop	hl
	jr	.rend

	db	"Ask me for using that code in you production..."

;Matrix line. Original algorithm & implementation (c)1998,2000 Vitaly Vidmirov
;-----------------------------------------------------------------------------
;draws line between points (x1,y1)-(x2,y2) (c,b)-(l,h)

draw_line
	ld	a,h
	sub	b
	jr	nc,.noswpy
	ld	a,c	;swap 1,2
	ld	c,l
	ld	l,a
	ld	a,b
	ld	b,h	
	ld	h,a
	sub	b
.noswpy	ld	d,a	;dy
	ld	a,l
	sub	c
	jr	nc,.noswpx
	cpl
	inc	a
	ld	e,a		;-dx
	cp	d
	jr	c,.linv1	;dx<dy, close to vertical axis

	ld	e,d		;close to horisontal axis
	ld	d,a		;swap dx,dy
	or	e
	ret	z		;zero length, exit
	ld	a,c
	and	$07
	add	a,a
	or	LINE_DMASK

.lndrw	ld	l,a
	ld	h,line_jmptb>>8
	ld	a,[hl+]
	ld	h,[hl]
	ld	l,a
	push	hl
	ld	l,b
	sla	l
	ld	h,line_vbuffer>>8
	ld	a,c
	and	$0f<<3
	rrca
	rrca
	rrca
	add	a,h
	ld	h,a
	ld	b,d
	inc	b
	ld	a,d
	srl	a
	ret

.linv1	or	d	;close to vertical axis
	ret	z	;zero length, exit
	ld	a,c
	and	$07
	add	a,a
	or	LINE_VMASK|LINE_DMASK
	jr	.lndrw

.noswpx	ld	e,a		;-dx
	cp	d
	jr	c,.linv2	;dx<dy, close to vertical axis

	ld	e,d		;close to horisontal axis
	ld	d,a		;swap dx,dy
	or	e
	ret	z		;zero length, exit
	ld	a,c
	and	$07
	add	a,a
	jr	.lndrw

.linv2	or	d	;close to vertical axis
	ret	z	;zero length, exit
	ld	a,c
	and	$07
	add	a,a
	or	LINE_VMASK
	jr	.lndrw

lnvi0	dec	b
	ret	z
	set	7,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi0
	add	a,d
lnvi1	dec	b
	ret	z
	set	6,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi1
	add	a,d
lnvi2	dec	b
	ret	z
	set	5,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi2
	add	a,d
lnvi3	dec	b
	ret	z
	set	4,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi3
	add	a,d
lnvi4	dec	b
	ret	z
	set	3,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi4
	add	a,d
lnvi5	dec	b
	ret	z
	set	2,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi5
	add	a,d
lnvi6	dec	b
	ret	z
	set	1,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi6
	add	a,d
lnvi7	dec	b
	ret	z
	set	0,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvi7
	add	a,d
	inc	h
	jr	lnvi0

lnvd0	dec	b
	ret	z
	set	7,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd0
	add	a,d
	dec	h
lnvd7	dec	b
	ret	z
	set	0,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd7
	add	a,d
lnvd6	dec	b
	ret	z
	set	1,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd6
	add	a,d
lnvd5	dec	b
	ret	z
	set	2,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd5
	add	a,d
lnvd4	dec	b
	ret	z
	set	3,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd4
	add	a,d
lnvd3	dec	b
	ret	z
	set	4,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd3
	add	a,d
lnvd2	dec	b
	ret	z
	set	5,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd2
	add	a,d
lnvd1	dec	b
	ret	z
	set	6,[hl]
	inc	l
	inc	l
	sub	e
	jr	nc,lnvd1
	add	a,d
	jr	lnvd0

lnhi0	dec	b
	ret	z
	set	7,[hl]
	sub	e
	jr	nc,lnhi1
	inc	l
	inc	l
	add	a,d
lnhi1	dec	b
	ret	z
	set	6,[hl]
	sub	e
	jr	nc,lnhi2
	inc	l
	inc	l
	add	a,d
lnhi2	dec	b
	ret	z
	set	5,[hl]
	sub	e
	jr	nc,lnhi3
	inc	l
	inc	l
	add	a,d
lnhi3	dec	b
	ret	z
	set	4,[hl]
	sub	e
	jr	nc,lnhi4
	inc	l
	inc	l
	add	a,d
lnhi4	dec	b
	ret	z
	set	3,[hl]
	sub	e
	jr	nc,lnhi5
	inc	l
	inc	l
	add	a,d
lnhi5	dec	b
	ret	z
	set	2,[hl]
	sub	e
	jr	nc,lnhi6
	inc	l
	inc	l
	add	a,d
lnhi6	dec	b
	ret	z
	set	1,[hl]
	sub	e
	jr	nc,lnhi7
	inc	l
	inc	l
	add	a,d
lnhi7	dec	b
	ret	z
	set	0,[hl]
	inc	h
	sub	e
	jr	nc,lnhi0
	inc	l
	inc	l
	add	a,d
	jr	lnhi0

lnhd0	dec	b
	ret	z
	set	7,[hl]
	dec	h
	sub	e
	jr	nc,lnhd7
	inc	l
	inc	l
	add	a,d
lnhd7	dec	b
	ret	z
	set	0,[hl]
	sub	e
	jr	nc,lnhd6
	inc	l
	inc	l
	add	a,d
lnhd6	dec	b
	ret	z
	set	1,[hl]
	sub	e
	jr	nc,lnhd5
	inc	l
	inc	l
	add	a,d
lnhd5	dec	b
	ret	z
	set	2,[hl]
	sub	e
	jr	nc,lnhd4
	inc	l
	inc	l
	add	a,d
lnhd4	dec	b
	ret	z
	set	3,[hl]
	sub	e
	jr	nc,lnhd3
	inc	l
	inc	l
	add	a,d
lnhd3	dec	b
	ret	z
	set	4,[hl]
	sub	e
	jr	nc,lnhd2
	inc	l
	inc	l
	add	a,d
lnhd2	dec	b
	ret	z
	set	5,[hl]
	sub	e
	jr	nc,lnhd1
	inc	l
	inc	l
	add	a,d
lnhd1	dec	b
	ret	z
	set	6,[hl]
	sub	e
	jr	nc,lnhd0
	inc	l
	inc	l
	add	a,d
	jr	lnhd0

;hl=src, de=dst
load_obj
	ld	b,8
	jp	mcpyb

;vertex rotator
;-----------------------------------------------
;hl,object_data

rotate_obj

	xor	a
	ldh	[cpnt],a

	inc	hl	;skip ptr to edges
	inc	hl
	ld	a,[hl+]
.rot	ld	[vcnt],a
	ld	a,[hl+]	;x
	ld	e,a
	ld	a,[hl+]	;y
	ld	d,a
	ld	a,[hl+]	;z
	ld	c,a
	push	hl

	ld	h,xxtb2>>8
	ld	a,[m0]
	ld	l,e
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,e
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	[rt1],a
	ld	a,[m1]
	ld	l,d
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,d
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	[rt2],a
	ld	a,[m2]
	ld	l,c
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,c
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	hl,rt1
	add	a,[hl]
	inc	l
	add	a,[hl]
	ld	[xn],a

	ld	h,xxtb2>>8
	ld	a,[m3]
	ld	l,e
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,e
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	[rt1],a
	ld	a,[m4]
	ld	l,d
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,d
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	[rt2],a
	ld	a,[m5]
	ld	l,c
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,c
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	hl,rt1
	add	a,[hl]
	inc	l
	add	a,[hl]
	ld	[yn],a

	ld	h,xxtb2>>8
	ld	a,[m6]
	ld	l,e
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,e
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	[rt1],a
	ld	a,[m7]
	ld	l,d
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,d
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	[rt2],a
	ld	a,[m8]
	ld	l,c
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,c
	ld	l,a
	ld	a,[hl]
	sub	b
	ld	hl,rt1
	add	a,[hl]
	inc	l
	add	a,[hl]

	ld	l,a
	rla
	sbc	a,a
	add	a,tb_z>>8
	ld	h,a		;ext.w
	ld	a,[opz]
	add	a,l
	ld	l,a
	adc	a,h
	sub	l
	ld	h,a
	ld	c,[hl]		;1/z multiplier

	ld	h,xxtb2>>8
	ld	d,tbpnt>>8
	ldh	a,[cpnt]
	ld	e,a
	ld	a,[opx]
	ld	b,a
	ldh	a,[xn]
	add	a,b
;	jr	.xx

	sra	a
	ld	l,c
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,c
	ld	l,a
	ld	a,[hl]
	sub	b
.xx	sra	a
	add	a,$40		;view center
	ld	[de],a		;xn
	inc	e
	ld	a,[opy]
	ld	b,a
	ldh	a,[yn]
	add	a,b
;	jr	.yy

	sra	a
	ld	l,c
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,c
	ld	l,a
	ld	a,[hl]
	sub	b

.yy	sra	a
	add	a,$40		;view center
	ld	[de],a		;yn
	inc	e
	ld	a,e
	ldh	[cpnt],a

	pop	hl
	ld	a,[vcnt]
	dec	a
	jp	nz,.rot

	ret

;hl= object desc = rx,ry,rz,px,py,pz,objdata => hl=objdata
rsetup:	ld	d,costb>>8
	ld	a,[hl+]	;rx
	ld	e,a
	ld	a,[de]
	ldh	[acx],a	;cos rx
	ld	a,e
	sub	$40
	ld	e,a
	ld	a,[de]
	ldh	[asx],a	;sin rx
	ld	a,[hl+]	;ry
	ld	e,a
	ld	a,[de]
	ldh	[acy],a	;cos ry
	ld	a,e
	sub	$40
	ld	e,a
	ld	a,[de]
	ldh	[asy],a	;sin ry
	ld	a,[hl+]	;rz
	ld	e,a
	ld	a,[de]
	ldh	[acz],a	;cos rz
	ld	a,e
	sub	$40
	ld	e,a
	ld	a,[de]
	ldh	[asz],a	;sin rz
	ld	a,[hl+]
	ld	[opx],a
	ld	a,[hl+]
	ld	[opy],a
	ld	a,[hl+]
	ld	[opz],a
	push	hl

	ld	a,[acz]
	ld	d,a
	ld	a,[acy]
	call	muls77
	sra	a
	ldh	[m0],a		;m0=cz*cy

	ld	a,[asz]
	ld	d,a
	ld	a,[acy]
	call	muls77
	sra	a
	ldh	[m1],a		;m1=sz*cy

	ld	a,[asy]
	cpl
	inc	a
	sra	a
	ldh	[m2],a		;m2=-sy

	ld	a,[asy]
	ld	d,a
	ld	a,[asx]
	call	muls77
	ld	c,a		;ma=sy*sx

	ld	a,[asz]
	ld	d,a
	ld	a,[acx]
	call	muls77
	ld	b,a

	ld	d,c
	ld	a,[acz]
	call	muls77
	sub	b
	sra	a
	ldh	[m3],a		;m3=cz*ma-sz*cx

	ld	a,[acz]
	ld	d,a
	ld	a,[acx]
	call	muls77
	ld	b,a

	ld	d,c
	ld	a,[asz]
	call	muls77
	add	a,b
	sra	a
	ldh	[m4],a		;m4=cz*cx-sz*ma

	ld	a,[acy]
	ld	d,a
	ld	a,[asx]
	call	muls77
	sra	a
	ldh	[m5],a		;m5=cy*sx

	ld	a,[asy]
	ld	d,a
	ld	a,[acx]
	call	muls77
	ld	c,a		;mb=sy*cx

	ld	a,[asz]
	ld	d,a
	ld	a,[asx]
	call	muls77
	ld	b,a

	ld	d,c
	ld	a,[acz]
	call	muls77
	add	a,b
	sra	a
	ldh	[m6],a		;m6=cz*mb+sz*sx


	ld	a,[acz]
	ld	d,a
	ld	a,[asx]
	call	muls77
	ld	b,a

	ld	d,c
	ld	a,[asz]
	call	muls77
	sub	b
	sra	a
	ldh	[m7],a		;m7=sz*mb-cz*sx

	ld	a,[acy]
	ld	d,a
	ld	a,[acx]
	call	muls77
	sra	a
	ldh	[m8],a		;m8=cy*cx

	pop	hl

	ld	a,[hl+]
	ld	h,[hl]
	ld	l,a
	ret

wires_vbl
	push	af
	push	hl
	push	de
	push	bc
	call	try2flip
	call	executor
	call	demostuff
	pop	bc
	pop	de
	pop	hl
	pop	af
	reti

;interrupt blitter
try2flip
	ldh	a,[flip_req]
	or	a
	ret	z	;no req
	cp	$80
	jr	nc,.phs3
	cp	$02
	jr	nc,.phs2
.phs1	ld	hl,line_vpage
	ld	c,[hl]
	ld	a,$80
	xor	[hl]
	ld	[hl],a
	ldh	a,[rLCDC]
	and	$89
	xor	$08	;flip scr
	ldh	[rLCDC],a
	xor	$08
	rrca
	rrca
	rrca
	and	$01
	ldh	[rVBK],a	;select shadow bank

	ld	a,c		;blit first block
	rlca
	inc	a
	ld	[rSVBK],a

	ld	h,$ff
	ld	de,$8800
	ld	bc,7<<8+(line_vbuffer>>8)

.cpy	ld	l,rHDMA1&$ff
	ld	[hl],c	;src
	inc	l
	ld	[hl],2*16	;center y
	inc	l
	ld	[hl],d	;dst
	inc	l
	ld	[hl],e
	inc	l
	ld	[hl],11
	inc	c
	ld	a,e
	add	a,16*12
	ld	e,a
	adc	a,d
	sub	e
	ld	d,a
	dec	b
	jr	nz,.cpy

	ld	a,[rambank]
	ld	[rSVBK],a

	ld	a,$02
	ld	[flip_req],a	;request acknowledged
	ret

.phs2	ld	a,[line_vpage]
	xor	$80
	rlca
	inc	a
	ld	[rSVBK],a

	ld	h,$ff
	ld	de,$8800+7*12*16
	ld	bc,8<<8+(line_vbuffer>>8)+7

.cpy2	ld	l,rHDMA1&$ff
	ld	[hl],c	;src
	inc	l
	ld	[hl],2*16	;center y
	inc	l
	ld	[hl],d	;dst
	inc	l
	ld	[hl],e
	inc	l
	ld	[hl],11
	inc	c
	ld	a,e
	add	a,16*12
	ld	e,a
	adc	a,d
	sub	e
	ld	d,a
	dec	b
	jr	nz,.cpy2

	ld	a,[rambank]
	ld	[rSVBK],a

	ld	hl,flip_req
	set	7,[hl]
	ret

.phs3	and	$01
	jr	nz,.phs1
	ld	[flip_req],a
	ret

;returns at top of frame

flip_vb	ld	hl,flip_req
	set	0,[hl]
.wt	bit	0,[hl]
	ret	z		;transfer started
	halt
	jr	.wt

show_title

	ld	a,$81
	ld	[rLCDC],a

	ld	hl,black_pal
	xor	a
	ld	b,3*4
	call	load_bpal

	ld	a,1
	ld	[rVBK],a

	ld	hl,title_atr
	ld	de,$9800+32*3
	ld	b,20
	ld	c,12
	call	load_vmap_lcd

	xor	a
	ld	[rVBK],a

	ld	hl,title_tiles
	ld	de,$8800
	ld	b,20*12
	call	load_tiles_lcd

	ld	hl,title_map
	ld	de,$9800+32*3
	ld	b,20
	ld	c,12
	call	load_vmap_lcd

.hc	halt

	xor	a
	ld	[rIE],a
	ld	[rIF],a

	ld	[sp_],sp
	ld	sp,title_pals

	ld	a,$80
	ldh	[rBCPS],a

	ld	hl,rLY
	ld	a,22
.wt	cp	[hl]
	jr	nz,.wt
.pl	pop	de
	ld	l,rSTAT&$ff
.whb	bit	1,[hl]
	jr	nz,.whb
.wr	ld	l,rBCPD&$ff

	ld	[hl],e
	ld	[hl],d

	REPT	15
	pop	de
	ld	[hl],e
	ld	[hl],d
	ENDR

	ld	a,[rLY]
	cp	96+24-2
	jr	c,.pl

	ld	l,rSTAT&$ff
.whbl	bit	1,[hl]
	jr	nz,.whbl

	ld	a,$80+2*8	;pal/2 col/0 = black
	ldh	[rBCPS],a
	xor	a
	ldh	[rBCPD],a
	ldh	[rBCPD],a

	ld	hl,sp_
	ld	a,[hl+]
	ld	h,[hl]
	ld	l,a
	ld	sp,hl

	ld	a,1
	ld	[rIE],a

	ld	de,time_continue
	call	cmp_time
	jr	nc,.hc

	halt
	ret

text_typer

	ld	hl,$9800
	xor	a
	ld	b,a
	call	memset_lcd

	ld	hl,font1
	ld	de,$9000
	ld	b,62
	call	load_tiles_lcd

	halt

	ld	hl,text_pal
	ld	b,1*4
	xor	a
	call	load_bpal

	ld	hl,text0
	ld	a,3
.page	push	af
	ld	de,$9800+4*32
	ld	c,5

.line	ld	b,20
.tp1	halt
	ld	a,[hl+]
	cp	$40		;skip "@"
	jr	c,@+3
	dec	a
	sub	$20
	ld	[de],a
	inc	de
	dec	b
	jr	nz,.tp1
	ld	a,e
	add	a,$1f
	ld	e,a
	adc	a,d
	sub	e
	ld	d,a
	ld	a,l
	add	a,19
	ld	l,a
	adc	a,h
	sub	l
	ld	h,a
	ld	b,20
.tp2	halt
	ld	a,[hl-]
	cp	$40		;skip "@"
	jr	c,@+3
	dec	a
	sub	$20
	ld	[de],a
	dec	de
	dec	b
	jr	nz,.tp2
	ld	a,e
	add	a,$21
	ld	e,a
	adc	a,d	
	sub	e
	ld	d,a
	ld	a,l
	add	a,21
	ld	l,a
	adc	a,h
	sub	l
	ld	h,a
	dec	c
	jr	nz,.line

	ld	b,192-8
	halt
	dec	b
	jr	nz,@-3
	pop	af
	dec	a
	jr	nz,.page

	ret

part_sweep	;known as "twist" ;-)

	xor	a
	ld	[vpage],a
	ld	[rSCX],a
	ld	[rLYC],a
	ld	a,STATF_LYC
	ld	[rSTAT],a		;lyc match interrupt
	ld	a,$83
	ld	[rLCDC],a

	ld	hl,vbl_hook+1
	ld	de,sweep_vbl
	ld	[hl],e
	inc	l
	ld	[hl],d

	ld	hl,null_pal
	ld	b,2*4
	xor	a
	call	load_bpal

	ld	a,$80
	ldh	[rBCPS],a
	xor	a
	ldh	[rBCPD],a
	ldh	[rBCPD],a

	ld	a,1
	ld	[rVBK],a
	ld	hl,$9800
	ld	b,0	;1024/4
	xor	a
	call	memset_lcd
	ld	[rVBK],a

	call	expand_screen		;vbl only enabled

	call	text_typer

	halt

	ld	hl,null_pal
	ld	b,2*4
	xor	a
	call	load_bpal

	call	remap_sweep_tiles

	ld	hl,url_tiles	;http://r-lab.nm.ru
	ld	de,$8000
	ld	b,10
	call	load_tiles_lcd

	ld	hl,sweep_tiles
	ld	de,$8800
	ld	b,e	;256 tiles
	call	load_tiles_lcd

	halt
	
	ld	a,112
	ld	[rSCX],a

	ld	a,$82
	ld	[rOCPS],a
	xor	a
	ld	[rOCPD],a
	ld	a,%01111100
	ld	[rOCPD],a

	ld	hl,$fe00
	ld	bc,$0a00

	ld	a,160-92+8
	
.spr	ld	[hl],144-16+16
	inc	l
	ld	[hl],a
	inc	l
	ld	[hl],c
	inc	l
	ld	[hl],0
	inc	l
	add	a,8
	inc	c
	dec	b
	jr	nz,.spr

	ld	hl,sweep_pal
	ld	b,4
	xor	a
	call	load_bpal

	xor	a
	ld	e,a
	ld	d,a

	halt
	xor	a
	ld	[rIF],a
	ld	a,STATF_MODE00
	ld	[rSTAT],a

	ld	a,3
	ld	[rIE],a

	ld	a,63
.mn1	push	af
	ld	h,costb>>8
	ld	l,a
	ld	a,64
	ld	c,[hl]
	sra	c
	sub	c
;	sub	16
	ld	[rSCX],a
	call	render_sweep
	pop	af
	dec	a
	jr	nz,.mn1

.mn2	call	render_sweep
	jr	.mn2

sweep_vbl
	push	af
	push	hl
	push	de
	push	bc
	call	play_mus
	pop	bc
	pop	de
	pop	hl
	pop	af
	reti

;d,e=sine2,1 [sweep_rot]   enter in vblank period!!!

render_sweep
	push	de
	ld	h,costb>>8
	ld	a,[rLY]
	cp	$98
	jr	nz,@-4
	ld	b,0
.rt	ld	l,e
	ld	a,[hl]
	sra	a
	sra	a
	ld	l,d
	ld	c,[hl]
	sra	c
	sra	c
	add	a,c
	ld	c,a
	ld	a,[sweep_rot]
	ld	l,a
	ld	a,[hl]
	sub	b
	add	a,c
	ld	[rSCY],a
	halt
	inc	e
	inc	d
	inc	d

	inc	b
	ld	a,[rLY]
	cp	$8f
	jr	nz,.rt
	halt

	pop	de
	inc	e
	inc	d
	inc	d

	ld	hl,sweep_rot
	inc	[hl]
	ret

expand_screen
	ld	a,24
	ld	[sweep_ytop],a
	ld	a,24+96
	ld	[sweep_ybot],a

	ld	b,(144-96)/2

	xor	a
	ld	[rIF],a
	LCD_WAIT
	jr	.exp1

.exp	ld	a,3
	ld	[rIE],a
	ld	a,[sweep_ytop]
	dec	a
	ld	[sweep_ytop],a
	ld	[rLYC],a
	ld	a,$80
	ld	hl,rBCPS
	halt
	ld	[hl+],a
	ld	[hl],color_sweep_bg0&$ff
	ld	[hl],color_sweep_bg0>>8
	ld	a,[sweep_ybot]
	inc	a
	ld	[sweep_ybot],a
	dec	a
	ld	[rLYC],a
	dec	l
	halt

.exp1	ld	hl,rBCPS
	ld	a,$80
	ld	[hl+],a
	xor	a
	ld	[hl],a
	ld	[hl],a
	inc	a
	ld	[rIE],a	;wait tof
	halt
	dec	b
	jr	nz,.exp

;now i'm fullscreen

	ld	hl,rBCPS
;	ld	a,1
;	ld	[rIE],a
;	rrca
	ld	a,$80
	ld	[hl+],a
	ld	[hl],color_sweep_bg0&$ff
	ld	[hl],color_sweep_bg0>>8

	ret

remap_sweep_tiles

	xor	a
	ld	[rVBK],a
	ld	hl,$9800
	ld	e,$80
.fclr	ld	b,8
.fcl2	LCD_WAIT
	ld	[hl],e
	inc	l
	inc	e
	ld	[hl],e
	inc	l
	inc	e
	dec	b
	jr	nz,.fcl2
	ld	b,4
.fcl3	LCD_WAIT
	xor	a
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	dec	b
	jr	nz,.fcl3

	ld	a,h
	cp	$9c
	jr	c,.fclr
	ret


;--------------------------------------------------------

setup0	di

	xor	a
	ldh	[rIE],a
	ldh	[rIF],a
	ld	hl,timer+1
	ld	[hl-],a
	ld	[hl],1
	ld	a,$d9
	ld	[vbl_hook],a
	ld	[lcd_hook],a

.lcd	ldh	a,[rLY]
	cp	$90
	jr	nz,.lcd
	xor	a
	ldh	[rLCDC],a     ; turn off LCD

	ld	a,[rKEY1]
	rlca
	jr	c,.skip
	ld	a,1
	ldh	[rKEY1], a
	stop
.skip
	ld	a,1
	ld	[rSVBK],a

	ld	hl,$8000
	ld	b,1
.clx	ld	a,b
	ld	[rVBK],a
	push	hl
	xor	a
.clr	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	bit	5,h
	jr	z,.clr
	pop	hl
	dec	b
	jr	z,.clx
	ld	b,32
	call	load_bpal

	ld	a,1
	call	init_mus

	ei
	ret

;- screen management --------------------------------------------

;palette loader
;hl=pallette; b=number of colors; a-first color
load_bpal
	or	$80
	ldh	[rBCPS],a
	ld	de,rBCPD
	srl	b
	ret	z
.ldp	LCD_WAIT
	ld	a,[hl+]	;transfers 1 palette at time
	ld	[de],a
	ld	a,[hl+]
	ld	[de],a
	ld	a,[hl+]
	ld	[de],a
	ld	a,[hl+]
	ld	[de],a
	dec	b
	jr	nz,.ldp
	ret

;hl,data de,dest bc,len
load_vm
	LCD_WAIT
	ld	a,[hl+]
	ld	[de],a
	inc	de
	dec	bc
	ld	a,b
	or	c
	ret	z
	ld	a,[hl+]
	ld	[de],a
	inc	de
	dec	bc
	ld	a,b
	or	c
	jr	nz,load_vm
	ret

mcpyb	ld	a,[hl+]
	ld	[de],a
	inc	de
	dec	b
	jr	nz,mcpyb
	ret

cls	ld	hl,$8800
.lp	LCD_WAIT
	xor	a
	REPT	16
	ld	[hl+],a
	ENDR
	ld	a,h
	cp	$98
	jr	c,.lp
	ret

;hl=from,de=to,b=# of tiles
load_tiles_lcd

.lpx	ld	c,4
.lp	LCD_WAIT
	REPT	3
	ld	a,[hl+]
	ld	[de],a
	inc	e
	ENDR
	ld	a,[hl+]
	ld	[de],a
	inc	de
	dec	c
	jr	nz,.lp
	dec	b
	jr	nz,.lpx
	ret

;hl=addr, b=# of bytes/4, a=byte
memset_lcd
	ld	c,a
.lp	LCD_WAIT
	ld	a,c
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	dec	b
	jr	nz,.lp
	ret

;hl=addr, b=# of bytes/4, a=byte
memset	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	dec	b
	jr	nz,memset
	ret

;hl=from,de=to,b=width,c=height

load_vmap_lcd

.lp	push	bc
	push	de
.lp1	LCD_WAIT
	ld	a,[hl+]
	ld	[de],a
	inc	de
	dec	b
	jr	nz,.lp1
	pop	de
	ld	a,e
	add	a,32
	ld	e,a
	adc	a,d
	sub	e
	ld	d,a
	pop	bc
	dec	c
	jr	nz,.lp
	ret

;clear linebuffer (a-vpage)
fast_cls
	rlca
	inc	a
	ld	[rambank],a
	ld	[rSVBK],a
	ld	hl,line_vbuffer
	xor	a
	ld	b,64
.clr	REPT	64
	ld	[hl+],a
	ENDR
	dec	b
	jr	nz,.clr
	ret

;wait vertical blank (int hook must be installed!)
wait_vbl
	push	af
	push	hl
	ld	hl,rIE
	ld	a,[hl]
	and	3
	ld	[hl],IEF_VBLANK
	halt
	ld	[hl],a
	pop	hl
	pop	af
	ret

;hl=*BGR color (8 bit per component); a=pal/color; c=scale[0..1..2][$00..7f..$ff] b=bias[0..31]
;>hl=next; de,bc untouched
set_scaled_bgcolor
	push	de
	push	bc

	or	$80
	ldh	[$68],a
	ld	de,0
	srl	c
	ld	a,3
.lp	push	af
	ld	a,[hl+]
	push	hl
	push	bc
	srl	a
	srl	a
	call	fmuls
	pop	bc
	push	bc
	srl	a	;range=[0..63]
	add	a,b	;+bias
	cp	31
	jr	c,@+4
	ld	a,31	;saturate

	ld	l,e
	ld	h,d
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	or	l
	ld	e,a
	ld	d,h
	pop	bc
	pop	hl
	pop	af
	dec	a
	jr	nz,.lp

	ld	a,e
	ldh	[$69],a
	ld	a,d
	ldh	[$69],a
	pop	bc
	pop	de
	ret

intena	xor	a
	ldh	[rIF],a
	ei
	ret

null_vbl
	push	af
	push	hl
	push	de
	push	bc
	call	demostuff
	pop	bc
	pop	de
	pop	hl
	pop	af
	reti

demostuff:
	call	play_mus
	ld	hl,timer
	inc	[hl]
	jr	nz,@+4
	inc	l
	inc	[hl]
	ret

;de=time
;return CF=time overflow
cmp_time
	ld	hl,timer
	xor	a
	sub	[hl]
	ld	c,a
	inc	hl
	sbc	a,[hl]
	sub	c
	ld	h,a
	ld	l,c
	add	hl,de
	ccf
	ret

make_scr2012

	ld	hl,$9800
	ld	c,l
	call	.mksc
	ld	hl,$9c00
	ld	c,8

;hl=addr,c=page[0 or 8]

.mksc	ld	a,1		;set attrs
	ld	[rVBK],a
	push	hl

	ld	b,3*32
.f1	LCD_WAIT
	ld	[hl],2
	inc	hl
	dec	b
	jr	nz,.f1
	ld	b,12
.fy	LCD_WAIT
	ld	a,1
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	ld	[hl+],a
	ld	e,15+12
.fx	LCD_WAIT
	ld	[hl],c
	inc	hl
	dec	e
	jr	nz,.fx
	dec	b
	jr	nz,.fy

	ld	b,3*32
.f2	LCD_WAIT
	ld	[hl],2
	inc	hl
	dec	b
	jr	nz,.f2

	xor	a		;set dats
	ld	[rVBK],a
	pop	hl

_make_scr2012	;reset locals

	ld	c,$80	;tile +#00
	ld	d,$40	;tile +#c0

	ld	b,3*32
.f1	LCD_WAIT
	ld	[hl],$7f	;no matter
	inc	hl
	dec	b
	jr	nz,.f1
	ld	b,12
.fy	ld	e,5
.fx1	LCD_WAIT
	ld	[hl],d
	inc	hl
	inc	d
	dec	e
	jr	nz,.fx1

	ld	e,15
.fx	LCD_WAIT
	ld	a,c
	ld	[hl+],a
	add	a,12
	ld	c,a
	dec	e
	jr	nz,.fx

	sub	15*12-1
	ld	c,a

	ld	e,12
.fx2	LCD_WAIT
	ld	[hl],$7f
	inc	hl
	dec	e
	jr	nz,.fx2

	dec	b
	jr	nz,.fy

	ld	b,3*32
.f2	LCD_WAIT
	ld	[hl],$7f
	inc	hl
	dec	b
	jr	nz,.f2

	ret

executor
	ld	hl,exec_ptr
	ld	a,[hl+]
	ld	h,[hl]
	ld	l,a

.loop	ld	e,[hl]
	inc	hl
	ld	d,[hl]
	inc	hl
	push	hl
	call	cmp_time
	pop	hl
	jr	c,.next
	ld	a,[hl+]
	ld	h,[hl]
	ld	l,a
	jp	[hl]

.next	inc	hl
	inc	hl
	ld	a,l
	ld	[exec_ptr+0],a
	ld	a,h
	ld	[exec_ptr+1],a
	jr	.loop

ex_idle
	ret

ex_zoom_in

	ld	a,[rZOOM]
	sub	2
	ret	c
	ld	[rZOOM],a
	ret

ex_zoom_out_quick

	ld	a,[rZOOM]
	add	a,15
	ret	c
	ld	[rZOOM],a
	ret

ex_zoom_out_small

	ld	a,[rZOOM]
	add	a,1
	ret	c
	ld	[rZOOM],a
	ret

;- math -------------------------------------------------------------------

;fast muls a[-1..1]=a*c, a=[-1..1](-64..63]; c=[-1..1](-128..127)
;c,de untouched
fmuls	ld	h,xxtb2>>8
	ld	l,c
	sra	l
	sub	l
	ld	l,a
	ld	b,[hl]
	add	a,c
	ld	l,a
	ld	a,[hl]
	sub	b
	ret

;signed d*a=>a		used by rsetup
muls77	ld	e,a
	bit	7,e
	jr	nz,.neg1
	bit	7,d
	jr	z,.pos1
	call	.neg0
	cpl
	inc	a
	ret

.neg0	xor	a
	sub	d
	ld	d,a
.pos1	xor	a
	REPT	7
	rr	e
	jr	nc,@+3
	add	a,d
	rra
	ENDR
;	adc	a,0	;round
	ret

.neg1	xor	a
	sub	e
	ld	e,a
	bit	7,d
	jr	nz,.neg0
	call	.pos1
	cpl
	inc	a
	ret

		
;a=(b(unsigned)*c(signed[-1..1]))&$ff00
mulsb	xor	a
	sla	c
	jr	c,mulsbn
mulsba	REPT 8
	rr	c
	jr	nc,@+3
	add	a,b
	rra
	ENDR
	rr	c
	ret
mulsbn	sub	c
	ld	c,a
	xor	a
	call	mulsba
	cpl
	inc	a
	ret

;- 3d objects --------------------------------------------------------------

;obj header[ram]: 	db	rx,ry,rz,px,py,pz
;			dw	obj_data_ptr
;obj_data[ra/om]:	dw	edge_ptr
;			db	vtx_num
;			db[]	x,y,z
;edge			db[]	line from,to
;			db	-1

OMAX	equ	$48

cube_hd
	ds	5
	db	$ff
	dw	cube_data

cube1_hd
	ds	5
	db	$ff
	dw	cube1_data

cube2_hd
	ds	5
	db	$ff
	dw	cube2_data

chain_hd
	ds	5
	db	$ff
	dw	chain_header

tball_hd
	ds	5
	db	$ff
	dw	tball_header

cube_data
	dw	cube_edge
	db	8
	db	-OMAX,-OMAX,-OMAX	;front
	db	-OMAX, OMAX,-OMAX
	db	 OMAX, OMAX,-OMAX
	db	 OMAX,-OMAX,-OMAX
	db	-OMAX,-OMAX, OMAX	;back
	db	-OMAX, OMAX, OMAX
	db	 OMAX, OMAX, OMAX
	db	 OMAX,-OMAX, OMAX

SKL	=	2
DVS	=	3

cube1_data:
	dw	cube_edge
	db	8
	db	-OMAX*SKL/DVS,-OMAX*SKL/DVS,-OMAX*SKL/DVS	;front
	db	-OMAX*SKL/DVS, OMAX*SKL/DVS,-OMAX*SKL/DVS
	db	 OMAX*SKL/DVS, OMAX*SKL/DVS,-OMAX*SKL/DVS
	db	 OMAX*SKL/DVS,-OMAX*SKL/DVS,-OMAX*SKL/DVS
	db	-OMAX*SKL/DVS,-OMAX*SKL/DVS, OMAX*SKL/DVS	;back
	db	-OMAX*SKL/DVS, OMAX*SKL/DVS, OMAX*SKL/DVS
	db	 OMAX*SKL/DVS, OMAX*SKL/DVS, OMAX*SKL/DVS
	db	 OMAX*SKL/DVS,-OMAX*SKL/DVS, OMAX*SKL/DVS

SKL	=	1
DVS	=	3

cube2_data:
	dw	cube_edge
	db	8
	db	-OMAX*SKL/DVS,-OMAX*SKL/DVS,-OMAX*SKL/DVS	;front
	db	-OMAX*SKL/DVS, OMAX*SKL/DVS,-OMAX*SKL/DVS
	db	 OMAX*SKL/DVS, OMAX*SKL/DVS,-OMAX*SKL/DVS
	db	 OMAX*SKL/DVS,-OMAX*SKL/DVS,-OMAX*SKL/DVS
	db	-OMAX*SKL/DVS,-OMAX*SKL/DVS, OMAX*SKL/DVS	;back
	db	-OMAX*SKL/DVS, OMAX*SKL/DVS, OMAX*SKL/DVS
	db	 OMAX*SKL/DVS, OMAX*SKL/DVS, OMAX*SKL/DVS
	db	 OMAX*SKL/DVS,-OMAX*SKL/DVS, OMAX*SKL/DVS

cube_edge
	db	0,1, 1,2, 2,3, 3,0
	db	4,5, 5,6, 6,7, 7,4
	db	0,4, 1,5, 2,6, 3,7
	db	-1

	include	"chain.inc"
	include	"tball.inc"

;- execution control -------------------------------------------------------

exec_data
	dw	time_start+108
	dw	ex_zoom_in
	dw	time_show_title-16
	dw	ex_idle
	dw	time_show_title
	dw	ex_zoom_out_quick
	dw	time_continue
	dw	ex_idle
	dw	time_continue+32
	dw	ex_zoom_out_small
	dw	time_fx1
	dw	ex_idle
	dw	time_fx1+32
	dw	ex_zoom_out_small
	dw	time_fx2
	dw	ex_idle
	dw	time_fx2+32
	dw	ex_zoom_out_small
	dw	-1
	dw	ex_idle

;- data section ------------------------------------------------------------

title_tiles
	incbin	"title.tls"
title_pals
	incbin	"title.pal"
title_map
	incbin	"title.map"
title_atr
	incbin	"title.atr"

;- colors (BGR triples!!!) ----------------------------------------
intro_rgb0	db	64,255,255	;mono color palette
		db	64,255,255
		db	64,255,255
		db	64,255,255

intro_rgb1	db	64,255,255	;r-lab presents palette
		db	42,170,170
		db	21,85,85
		db	0,0,0

null_pal	dw	%0001111111111111
		dw	%0001111111111111
		dw	%0001111111111111
		dw	%0001111111111111
		dw	%0001111111111111
		dw	%0001111111111111
		dw	%0001111111111111
		dw	%0001111111111111

part_3d_pal	dw	%0001111111111111
		dw	%0000100010000100
		dw	%0111101111011000
		dw	%0000000000000000

		dw	%0001111110011100
		dw	%0001000110001100
		dw	%0000100010000100
		dw	%0000000000000000

sweep_pal	dw	color_sweep_bg0
		dw	%0111111111111111
		dw	%0000000000000000
		dw	%0011110111101111

text_pal	dw	color_sweep_bg0
		dw	%0111110001000010
		dw	%0001101111011110
		dw	%0000000000000000

text0
 db	"                    "
 db	"                    "
 db	"                    "
 db	" THIS IS THE END OF "
 db	"   MY SMALL INTRO   "
 db	"     RELEASED FOR   "
 db	"G B D E V '  2 0 0 0"
 db	"                    "
 db	"                    "
 db	"                    "

 db	"                    "
 db	"CODE............DARK"
 db	"GFX........DARK,JUGE"
 db	"OBJECTS.........DARK"
 db	"MUSIC...........DARK"
 db	"MUSIC ENGINE....DARK"
 db	"                    "
 db	" STARTED 3 DAYS BE4 "
 db	"   COMPETITION ;-)  "
 db	"                    "

 db	"                    "
 db	"  GREETZ FLYING TO  "
 db	"                    "
 db	"         ALL        "
 db	"       GAMEBOY      "
 db	"     DEVELOPERS     "
 db	"                    "
 db	"         AT         "
 db	"      #GAMEBOY      "
 db	"                    "


	section "datatab1",HOME[$3a00]

costb	incbin	"cos7f.tab"	;[256]
xxtb2	incbin	"x2.tab"	;[256]

tb_z
DAT1	=0
	REPT	512
DAT2	=DAT1>>8
	IF DAT2
DAT2	=($7f00/(DAT2+$c0))
	ELSE
DAT2	=$7f
	ENDC
	IF DAT2<$80
	db	DAT2
	ELSE
	db	$7f
	ENDC
DAT1	=DAT1+$100
	ENDR

line_jmptb
	dw	lnhi0,lnhi1,lnhi2,lnhi3,lnhi4,lnhi5,lnhi6,lnhi7
	dw	lnhd0,lnhd1,lnhd2,lnhd3,lnhd4,lnhd5,lnhd6,lnhd7
	dw	lnvi0,lnvi1,lnvi2,lnvi3,lnvi4,lnvi5,lnvi6,lnvi7
	dw	lnvd0,lnvd1,lnvd2,lnvd3,lnvd4,lnvd5,lnvd6,lnvd7

	include	"url.inc"	;url_tiles

black_pal	;ds	64 - filled with crap

	section "datafiles",DATA[$4000] ;aligned
sweep_tiles
	incbin	"sweep.tls"	;[4096]
font1
	incbin	"font1.tls"

	include "r-lab2b.inc"	;logo2_tiles
	include	"rlabpres.inc"	;logo1_map0 logo1_tiles

	section "music",CODE[$5e00]
	incbin	"plr.bin"